# swagger-java-client

DiscoverSnoop
- API version: 0.9.240913
  - Build date: 2024-09-16T13:04:42.809393229Z[GMT]

API for DiscoverSnoop Service


*Automatically generated by the [Swagger Codegen](https://github.com/swagger-api/swagger-codegen)*


## Requirements

Building the API client library requires:
1. Java 1.7+
2. Maven/Gradle

## Installation

To install the API client library to your local Maven repository, simply execute:

```shell
mvn clean install
```

To deploy it to a remote Maven repository instead, configure the settings of the repository and execute:

```shell
mvn clean deploy
```

Refer to the [OSSRH Guide](http://central.sonatype.org/pages/ossrh-guide.html) for more information.

### Maven users

Add this dependency to your project's POM:

```xml
<dependency>
  <groupId>io.swagger</groupId>
  <artifactId>swagger-java-client</artifactId>
  <version>1.0.0</version>
  <scope>compile</scope>
</dependency>
```

### Gradle users

Add this dependency to your project's build file:

```groovy
compile "io.swagger:swagger-java-client:1.0.0"
```

### Others

At first generate the JAR by executing:

```shell
mvn clean package
```

Then manually install the following JARs:

* `target/swagger-java-client-1.0.0.jar`
* `target/lib/*.jar`

## Getting Started

Please follow the [installation](#installation) instruction and execute the following Java code:

```java
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AlertsApi;

import java.io.File;
import java.util.*;

public class AlertsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        AlertsApi apiInstance = new AlertsApi();
        String id = "id_example"; // String | ID of the alert to edit ; if adding a new one leave blank
        String alertname = "alertname_example"; // String | Name of the alert
        Boolean activated = true; // Boolean | Should the alert be activated or not
        Integer type = 56; // Integer | Alert type (1= New content for website, 2=New perfirming contents)
        Integer channel = 56; // Integer | 1 for email, 2 for Slack, 3 for Google Chat
        String recipient = "recipient_example"; // String | Email address of recipient or webhook for Slack/Gchat
        String param1 = "param1_example"; // String | Parameter 1 (meaning changes with alert type)
        String param2 = "param2_example"; // String | Parameter 2 (meaning changes with alert type)
        String param3 = "param3_example"; // String | Parameter 3 (meaning changes with alert type)
        String param4 = "param4_example"; // String | Parameter 4 (meaning changes with alert type)
        String param5 = "param5_example"; // String | Parameter 5 (meaning changes with alert type)
        try {
            List<Domains> result = apiInstance.alertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AlertsApi#alertsChangeGet");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AlertsApi;

import java.io.File;
import java.util.*;

public class AlertsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        AlertsApi apiInstance = new AlertsApi();
        String id = "id_example"; // String | alert id to delete
        try {
            List<TransactionInfo> result = apiInstance.alertsDeleteGet(id);
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AlertsApi#alertsDeleteGet");
            e.printStackTrace();
        }
    }
}
import io.swagger.client.*;
import io.swagger.client.auth.*;
import io.swagger.client.model.*;
import io.swagger.client.api.AlertsApi;

import java.io.File;
import java.util.*;

public class AlertsApiExample {

    public static void main(String[] args) {
        ApiClient defaultClient = Configuration.getDefaultApiClient();


        AlertsApi apiInstance = new AlertsApi();
        try {
            List<Alerts> result = apiInstance.alertsGet();
            System.out.println(result);
        } catch (ApiException e) {
            System.err.println("Exception when calling AlertsApi#alertsGet");
            e.printStackTrace();
        }
    }
}
```

## Documentation for API Endpoints

All URIs are relative to *https://api.discoversnoop.com*

Class | Method | HTTP request | Description
------------ | ------------- | ------------- | -------------
*AlertsApi* | [**alertsChangeGet**](docs/AlertsApi.md#alertsChangeGet) | **GET** /alerts_change | Edit or insert new alert
*AlertsApi* | [**alertsDeleteGet**](docs/AlertsApi.md#alertsDeleteGet) | **GET** /alerts_delete | Permanently delete the alert
*AlertsApi* | [**alertsGet**](docs/AlertsApi.md#alertsGet) | **GET** /alerts | Get alerts for user account
*FavsApi* | [**favsAddGet**](docs/FavsApi.md#favsAddGet) | **GET** /favs_add | Create a new fav
*FavsApi* | [**favsDeleteGet**](docs/FavsApi.md#favsDeleteGet) | **GET** /favs_delete | Permanently delete the fav
*FavsApi* | [**favsGet**](docs/FavsApi.md#favsGet) | **GET** /favs | Get favorites
*FavsApi* | [**favsUpdateGet**](docs/FavsApi.md#favsUpdateGet) | **GET** /favs_update | Update the fav
*HistoricalApi* | [**categoriesGet**](docs/HistoricalApi.md#categoriesGet) | **GET** /categories | Get historical stats for categories
*HistoricalApi* | [**categoryGet**](docs/HistoricalApi.md#categoryGet) | **GET** /category | Get history for category ID
*HistoricalApi* | [**domainGet**](docs/HistoricalApi.md#domainGet) | **GET** /domain | Get history for domain name
*HistoricalApi* | [**domainsGet**](docs/HistoricalApi.md#domainsGet) | **GET** /domains | Get historical stats for domains
*HistoricalApi* | [**pageGet**](docs/HistoricalApi.md#pageGet) | **GET** /page | Get page history for URL
*HistoricalApi* | [**pagesGet**](docs/HistoricalApi.md#pagesGet) | **GET** /pages | Get historical stats for pages
*KbApi* | [**kbArticlesGet**](docs/KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles
*LiveApi* | [**livecategoriesGet**](docs/LiveApi.md#livecategoriesGet) | **GET** /livecategories | Get livedata stats for categories
*LiveApi* | [**livedomainsGet**](docs/LiveApi.md#livedomainsGet) | **GET** /livedomains | Get livedata stats for domains
*LiveApi* | [**livepagesGet**](docs/LiveApi.md#livepagesGet) | **GET** /livepages | Get livedata stats for pages
*UserApi* | [**userCountriesChangeGet**](docs/UserApi.md#userCountriesChangeGet) | **GET** /user_countries_change | Change user&#x27;s activated countries
*UserApi* | [**userCustidChangeGet**](docs/UserApi.md#userCustidChangeGet) | **GET** /user_custid_change | Change user customer id. This function is system reserved
*UserApi* | [**userDeleteGet**](docs/UserApi.md#userDeleteGet) | **GET** /user_delete | Permanently delete the user
*UserApi* | [**userDetailsChangeGet**](docs/UserApi.md#userDetailsChangeGet) | **GET** /user_details_change | Change user details
*UserApi* | [**userLoginGet**](docs/UserApi.md#userLoginGet) | **GET** /user_login | Login user with his credentials
*UserApi* | [**userMessagesGet**](docs/UserApi.md#userMessagesGet) | **GET** /user_messages | Get messages for user
*UserApi* | [**userPasswordChangeGet**](docs/UserApi.md#userPasswordChangeGet) | **GET** /user_password_change | Change user password
*UserApi* | [**userPasswordResetGet**](docs/UserApi.md#userPasswordResetGet) | **GET** /user_password_reset | Reset user password
*UserApi* | [**userRefreshSubscriptionGet**](docs/UserApi.md#userRefreshSubscriptionGet) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
*UserApi* | [**userRegisterGet**](docs/UserApi.md#userRegisterGet) | **GET** /user_register | Login user with his credentials

## Documentation for Models

 - [AlertCollection](docs/AlertCollection.md)
 - [Alerts](docs/Alerts.md)
 - [Categories](docs/Categories.md)
 - [CategoriesCollection](docs/CategoriesCollection.md)
 - [Category](docs/Category.md)
 - [DistributionCollection](docs/DistributionCollection.md)
 - [Domain](docs/Domain.md)
 - [Domains](docs/Domains.md)
 - [DomainsCollection](docs/DomainsCollection.md)
 - [Favs](docs/Favs.md)
 - [FavsCollection](docs/FavsCollection.md)
 - [HistoryCollection](docs/HistoryCollection.md)
 - [KB](docs/KB.md)
 - [KBCollection](docs/KBCollection.md)
 - [Message](docs/Message.md)
 - [MessageCollection](docs/MessageCollection.md)
 - [MetricsCollection](docs/MetricsCollection.md)
 - [Page](docs/Page.md)
 - [Pages](docs/Pages.md)
 - [PagesCollection](docs/PagesCollection.md)
 - [TransactionInfo](docs/TransactionInfo.md)
 - [UserCollection](docs/UserCollection.md)
 - [UserInfo](docs/UserInfo.md)

## Documentation for Authorization

Authentication schemes defined for the API:
### bearerAuth



## Recommendation

It's recommended to create an instance of `ApiClient` per thread in a multithreaded environment to avoid any potential issues.

## Author


