# AlertsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**alertsChangeGet**](AlertsApi.md#alertsChangeGet) | **GET** /alerts_change | Edit or insert new alert
[**alertsDeleteGet**](AlertsApi.md#alertsDeleteGet) | **GET** /alerts_delete | Permanently delete the alert
[**alertsGet**](AlertsApi.md#alertsGet) | **GET** /alerts | Get alerts for user account

<a name="alertsChangeGet"></a>
# **alertsChangeGet**
> List&lt;Domains&gt; alertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5)

Edit or insert new alert

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AlertsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


AlertsApi apiInstance = new AlertsApi();
String id = "id_example"; // String | ID of the alert to edit ; if adding a new one leave blank
String alertname = "alertname_example"; // String | Name of the alert
Boolean activated = true; // Boolean | Should the alert be activated or not
Integer type = 56; // Integer | Alert type (1= New content for website, 2=New perfirming contents)
Integer channel = 56; // Integer | 1 for email, 2 for Slack, 3 for Google Chat
String recipient = "recipient_example"; // String | Email address of recipient or webhook for Slack/Gchat
String param1 = "param1_example"; // String | Parameter 1 (meaning changes with alert type)
String param2 = "param2_example"; // String | Parameter 2 (meaning changes with alert type)
String param3 = "param3_example"; // String | Parameter 3 (meaning changes with alert type)
String param4 = "param4_example"; // String | Parameter 4 (meaning changes with alert type)
String param5 = "param5_example"; // String | Parameter 5 (meaning changes with alert type)
try {
    List<Domains> result = apiInstance.alertsChangeGet(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AlertsApi#alertsChangeGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the alert to edit ; if adding a new one leave blank |
 **alertname** | **String**| Name of the alert |
 **activated** | **Boolean**| Should the alert be activated or not |
 **type** | **Integer**| Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) |
 **channel** | **Integer**| 1 for email, 2 for Slack, 3 for Google Chat |
 **recipient** | **String**| Email address of recipient or webhook for Slack/Gchat |
 **param1** | **String**| Parameter 1 (meaning changes with alert type) | [optional]
 **param2** | **String**| Parameter 2 (meaning changes with alert type) | [optional]
 **param3** | **String**| Parameter 3 (meaning changes with alert type) | [optional]
 **param4** | **String**| Parameter 4 (meaning changes with alert type) | [optional]
 **param5** | **String**| Parameter 5 (meaning changes with alert type) | [optional]

### Return type

[**List&lt;Domains&gt;**](Domains.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="alertsDeleteGet"></a>
# **alertsDeleteGet**
> List&lt;TransactionInfo&gt; alertsDeleteGet(id)

Permanently delete the alert

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AlertsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


AlertsApi apiInstance = new AlertsApi();
String id = "id_example"; // String | alert id to delete
try {
    List<TransactionInfo> result = apiInstance.alertsDeleteGet(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AlertsApi#alertsDeleteGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| alert id to delete |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="alertsGet"></a>
# **alertsGet**
> List&lt;Alerts&gt; alertsGet()

Get alerts for user account

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.AlertsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


AlertsApi apiInstance = new AlertsApi();
try {
    List<Alerts> result = apiInstance.alertsGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling AlertsApi#alertsGet");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List&lt;Alerts&gt;**](Alerts.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

