# FavsApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**favsAddGet**](FavsApi.md#favsAddGet) | **GET** /favs_add | Create a new fav
[**favsDeleteGet**](FavsApi.md#favsDeleteGet) | **GET** /favs_delete | Permanently delete the fav
[**favsGet**](FavsApi.md#favsGet) | **GET** /favs | Get favorites
[**favsUpdateGet**](FavsApi.md#favsUpdateGet) | **GET** /favs_update | Update the fav

<a name="favsAddGet"></a>
# **favsAddGet**
> List&lt;TransactionInfo&gt; favsAddGet(name, action, parameters)

Create a new fav

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FavsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


FavsApi apiInstance = new FavsApi();
String name = "name_example"; // String | Name of the fav.
String action = "action_example"; // String | Action to be opened.
String parameters = "parameters_example"; // String | Action's parameters encoded in JSON.
try {
    List<TransactionInfo> result = apiInstance.favsAddGet(name, action, parameters);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FavsApi#favsAddGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **name** | **String**| Name of the fav. | [optional]
 **action** | **String**| Action to be opened. | [optional]
 **parameters** | **String**| Action&#x27;s parameters encoded in JSON. | [optional]

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsDeleteGet"></a>
# **favsDeleteGet**
> List&lt;TransactionInfo&gt; favsDeleteGet(id)

Permanently delete the fav

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FavsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


FavsApi apiInstance = new FavsApi();
String id = "id_example"; // String | ID of the fav to delete.
try {
    List<TransactionInfo> result = apiInstance.favsDeleteGet(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FavsApi#favsDeleteGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the fav to delete. | [optional]

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsGet"></a>
# **favsGet**
> List&lt;Favs&gt; favsGet(id)

Get favorites

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FavsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


FavsApi apiInstance = new FavsApi();
String id = "id_example"; // String | ID of the requested fav. ignore or set to 0 to get the full favs list
try {
    List<Favs> result = apiInstance.favsGet(id);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FavsApi#favsGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the requested fav. ignore or set to 0 to get the full favs list | [optional]

### Return type

[**List&lt;Favs&gt;**](Favs.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="favsUpdateGet"></a>
# **favsUpdateGet**
> List&lt;TransactionInfo&gt; favsUpdateGet(id, name, action, parameters, scheduled, scheduledto)

Update the fav

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.FavsApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


FavsApi apiInstance = new FavsApi();
String id = "id_example"; // String | ID of the fav that should be edited
String name = "name_example"; // String | Name of the fav.
String action = "action_example"; // String | Action to be opened.
String parameters = "parameters_example"; // String | Action's parameters encoded in JSON.
Integer scheduled = 56; // Integer | 0 if not scheduled, else x in hours
String scheduledto = "scheduledto_example"; // String | email address of the recipient of this report
try {
    List<TransactionInfo> result = apiInstance.favsUpdateGet(id, name, action, parameters, scheduled, scheduledto);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling FavsApi#favsUpdateGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **id** | **String**| ID of the fav that should be edited |
 **name** | **String**| Name of the fav. | [optional]
 **action** | **String**| Action to be opened. | [optional]
 **parameters** | **String**| Action&#x27;s parameters encoded in JSON. | [optional]
 **scheduled** | **Integer**| 0 if not scheduled, else x in hours | [optional]
 **scheduledto** | **String**| email address of the recipient of this report | [optional]

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

