# KbApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**kbArticlesGet**](KbApi.md#kbArticlesGet) | **GET** /kb_articles | Get knowledge base articles

<a name="kbArticlesGet"></a>
# **kbArticlesGet**
> List&lt;KB&gt; kbArticlesGet(article)

Get knowledge base articles

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.KbApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


KbApi apiInstance = new KbApi();
Integer article = 56; // Integer | ID of the requested article. 0 to get the full article list
try {
    List<KB> result = apiInstance.kbArticlesGet(article);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling KbApi#kbArticlesGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **article** | **Integer**| ID of the requested article. 0 to get the full article list | [optional]

### Return type

[**List&lt;KB&gt;**](KB.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

