# UserApi

All URIs are relative to *https://api.discoversnoop.com*

Method | HTTP request | Description
------------- | ------------- | -------------
[**userCountriesChangeGet**](UserApi.md#userCountriesChangeGet) | **GET** /user_countries_change | Change user&#x27;s activated countries
[**userCustidChangeGet**](UserApi.md#userCustidChangeGet) | **GET** /user_custid_change | Change user customer id. This function is system reserved
[**userDeleteGet**](UserApi.md#userDeleteGet) | **GET** /user_delete | Permanently delete the user
[**userDetailsChangeGet**](UserApi.md#userDetailsChangeGet) | **GET** /user_details_change | Change user details
[**userLoginGet**](UserApi.md#userLoginGet) | **GET** /user_login | Login user with his credentials
[**userMessagesGet**](UserApi.md#userMessagesGet) | **GET** /user_messages | Get messages for user
[**userPasswordChangeGet**](UserApi.md#userPasswordChangeGet) | **GET** /user_password_change | Change user password
[**userPasswordResetGet**](UserApi.md#userPasswordResetGet) | **GET** /user_password_reset | Reset user password
[**userRefreshSubscriptionGet**](UserApi.md#userRefreshSubscriptionGet) | **GET** /user_refresh_subscription | Refresh user rights with his Customer ID. This function is system reserved
[**userRegisterGet**](UserApi.md#userRegisterGet) | **GET** /user_register | Login user with his credentials

<a name="userCountriesChangeGet"></a>
# **userCountriesChangeGet**
> List&lt;TransactionInfo&gt; userCountriesChangeGet(countries, categories)

Change user&#x27;s activated countries

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String countries = "countries_example"; // String | json encoded string representing countries to activate
String categories = "categories_example"; // String | json encoded string representing categories ID to activate
try {
    List<TransactionInfo> result = apiInstance.userCountriesChangeGet(countries, categories);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userCountriesChangeGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **countries** | **String**| json encoded string representing countries to activate |
 **categories** | **String**| json encoded string representing categories ID to activate |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userCustidChangeGet"></a>
# **userCustidChangeGet**
> List&lt;TransactionInfo&gt; userCustidChangeGet(custid)

Change user customer id. This function is system reserved

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String custid = "custid_example"; // String | new customer id for user
try {
    List<TransactionInfo> result = apiInstance.userCustidChangeGet(custid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userCustidChangeGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **String**| new customer id for user |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userDeleteGet"></a>
# **userDeleteGet**
> List&lt;TransactionInfo&gt; userDeleteGet()

Permanently delete the user

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
try {
    List<TransactionInfo> result = apiInstance.userDeleteGet();
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userDeleteGet");
    e.printStackTrace();
}
```

### Parameters
This endpoint does not need any parameter.

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userDetailsChangeGet"></a>
# **userDetailsChangeGet**
> List&lt;TransactionInfo&gt; userDetailsChangeGet(email, fname, lname)

Change user details

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String email = "email_example"; // String | new email address for user
String fname = "fname_example"; // String | new firstname for user
String lname = "lname_example"; // String | new lastname for user
try {
    List<TransactionInfo> result = apiInstance.userDetailsChangeGet(email, fname, lname);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userDetailsChangeGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| new email address for user |
 **fname** | **String**| new firstname for user |
 **lname** | **String**| new lastname for user |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userLoginGet"></a>
# **userLoginGet**
> List&lt;UserInfo&gt; userLoginGet(email, password, pin)

Login user with his credentials

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String email = "email_example"; // String | email address for user
String password = "password_example"; // String | password for user
Integer pin = 56; // Integer | pin code to validate account creation ; when using pin code, password must be set to \"loginwithpin\"
try {
    List<UserInfo> result = apiInstance.userLoginGet(email, password, pin);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userLoginGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user |
 **password** | **String**| password for user |
 **pin** | **Integer**| pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; | [optional]

### Return type

[**List&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userMessagesGet"></a>
# **userMessagesGet**
> List&lt;Message&gt; userMessagesGet(message)

Get messages for user

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
Integer message = 56; // Integer | ID of the requested message. 0 to get the full message list
try {
    List<Message> result = apiInstance.userMessagesGet(message);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userMessagesGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **message** | **Integer**| ID of the requested message. 0 to get the full message list | [optional]

### Return type

[**List&lt;Message&gt;**](Message.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userPasswordChangeGet"></a>
# **userPasswordChangeGet**
> List&lt;TransactionInfo&gt; userPasswordChangeGet(email, password, newpassword)

Change user password

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String email = "email_example"; // String | email address for user
String password = "password_example"; // String | current password for user
String newpassword = "newpassword_example"; // String | new password to set up for user
try {
    List<TransactionInfo> result = apiInstance.userPasswordChangeGet(email, password, newpassword);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userPasswordChangeGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user |
 **password** | **String**| current password for user |
 **newpassword** | **String**| new password to set up for user |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userPasswordResetGet"></a>
# **userPasswordResetGet**
> List&lt;TransactionInfo&gt; userPasswordResetGet(email)

Reset user password

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String email = "email_example"; // String | email address for user
try {
    List<TransactionInfo> result = apiInstance.userPasswordResetGet(email);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userPasswordResetGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user |

### Return type

[**List&lt;TransactionInfo&gt;**](TransactionInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userRefreshSubscriptionGet"></a>
# **userRefreshSubscriptionGet**
> List&lt;UserInfo&gt; userRefreshSubscriptionGet(custid)

Refresh user rights with his Customer ID. This function is system reserved

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String custid = "custid_example"; // String | Customer ID for the user
try {
    List<UserInfo> result = apiInstance.userRefreshSubscriptionGet(custid);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userRefreshSubscriptionGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **custid** | **String**| Customer ID for the user |

### Return type

[**List&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

<a name="userRegisterGet"></a>
# **userRegisterGet**
> List&lt;UserInfo&gt; userRegisterGet(email, password, fname, lname, referrer)

Login user with his credentials

### Example
```java
// Import classes:
//import io.swagger.client.ApiClient;
//import io.swagger.client.ApiException;
//import io.swagger.client.Configuration;
//import io.swagger.client.auth.*;
//import io.swagger.client.api.UserApi;

ApiClient defaultClient = Configuration.getDefaultApiClient();


UserApi apiInstance = new UserApi();
String email = "email_example"; // String | email address for user
String password = "password_example"; // String | password for user
String fname = "fname_example"; // String | new firstname for user
String lname = "lname_example"; // String | new lastname for user
String referrer = "referrer_example"; // String | referrer for this user. should be urlencoded
try {
    List<UserInfo> result = apiInstance.userRegisterGet(email, password, fname, lname, referrer);
    System.out.println(result);
} catch (ApiException e) {
    System.err.println("Exception when calling UserApi#userRegisterGet");
    e.printStackTrace();
}
```

### Parameters

Name | Type | Description  | Notes
------------- | ------------- | ------------- | -------------
 **email** | **String**| email address for user |
 **password** | **String**| password for user |
 **fname** | **String**| new firstname for user |
 **lname** | **String**| new lastname for user |
 **referrer** | **String**| referrer for this user. should be urlencoded | [optional]

### Return type

[**List&lt;UserInfo&gt;**](UserInfo.md)

### Authorization

[bearerAuth](../README.md#bearerAuth)

### HTTP request headers

 - **Content-Type**: Not defined
 - **Accept**: application/json

