/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Alerts;
import io.swagger.client.model.Domains;
import io.swagger.client.model.TransactionInfo;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class AlertsApi {
    private ApiClient apiClient;
    private Map<String, String> headers;

    public AlertsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public AlertsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public void setHeadersOverrides(Map<String, String> headers) {
        this.headers = headers;
    }

    /**
     * Build call for alertsChangeGet
     * @param id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param alertname Name of the alert (required)
     * @param activated Should the alert be activated or not (required)
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) (required)
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat (required)
     * @param recipient Email address of recipient or webhook for Slack/Gchat (required)
     * @param param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call alertsChangeGetCall(String id, String alertname, Boolean activated, Integer type, Integer channel, String recipient, String param1, String param2, String param3, String param4, String param5, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/alerts_change";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));
        if (alertname != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("alertname", alertname));
        if (activated != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("activated", activated));
        if (type != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("type", type));
        if (channel != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("channel", channel));
        if (recipient != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("recipient", recipient));
        if (param1 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("param1", param1));
        if (param2 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("param2", param2));
        if (param3 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("param3", param3));
        if (param4 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("param4", param4));
        if (param5 != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("param5", param5));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call alertsChangeGetValidateBeforeCall(String id, String alertname, Boolean activated, Integer type, Integer channel, String recipient, String param1, String param2, String param3, String param4, String param5, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling alertsChangeGet(Async)");
        }
        // verify the required parameter 'alertname' is set
        if (alertname == null) {
            throw new ApiException("Missing the required parameter 'alertname' when calling alertsChangeGet(Async)");
        }
        // verify the required parameter 'activated' is set
        if (activated == null) {
            throw new ApiException("Missing the required parameter 'activated' when calling alertsChangeGet(Async)");
        }
        // verify the required parameter 'type' is set
        if (type == null) {
            throw new ApiException("Missing the required parameter 'type' when calling alertsChangeGet(Async)");
        }
        // verify the required parameter 'channel' is set
        if (channel == null) {
            throw new ApiException("Missing the required parameter 'channel' when calling alertsChangeGet(Async)");
        }
        // verify the required parameter 'recipient' is set
        if (recipient == null) {
            throw new ApiException("Missing the required parameter 'recipient' when calling alertsChangeGet(Async)");
        }
        
        com.squareup.okhttp.Call call = alertsChangeGetCall(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Edit or insert new alert
     * 
     * @param id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param alertname Name of the alert (required)
     * @param activated Should the alert be activated or not (required)
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) (required)
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat (required)
     * @param recipient Email address of recipient or webhook for Slack/Gchat (required)
     * @param param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param param5 Parameter 5 (meaning changes with alert type) (optional)
     * @return List&lt;Domains&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Domains> alertsChangeGet(String id, String alertname, Boolean activated, Integer type, Integer channel, String recipient, String param1, String param2, String param3, String param4, String param5) throws ApiException {
        ApiResponse<List<Domains>> resp = alertsChangeGetWithHttpInfo(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5);
        return resp.getData();
    }

    /**
     * Edit or insert new alert
     * 
     * @param id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param alertname Name of the alert (required)
     * @param activated Should the alert be activated or not (required)
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) (required)
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat (required)
     * @param recipient Email address of recipient or webhook for Slack/Gchat (required)
     * @param param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param param5 Parameter 5 (meaning changes with alert type) (optional)
     * @return ApiResponse&lt;List&lt;Domains&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Domains>> alertsChangeGetWithHttpInfo(String id, String alertname, Boolean activated, Integer type, Integer channel, String recipient, String param1, String param2, String param3, String param4, String param5) throws ApiException {
        com.squareup.okhttp.Call call = alertsChangeGetValidateBeforeCall(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, null, null);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Edit or insert new alert (asynchronously)
     * 
     * @param id ID of the alert to edit ; if adding a new one leave blank (required)
     * @param alertname Name of the alert (required)
     * @param activated Should the alert be activated or not (required)
     * @param type Alert type (1&#x3D; New content for website, 2&#x3D;New perfirming contents) (required)
     * @param channel 1 for email, 2 for Slack, 3 for Google Chat (required)
     * @param recipient Email address of recipient or webhook for Slack/Gchat (required)
     * @param param1 Parameter 1 (meaning changes with alert type) (optional)
     * @param param2 Parameter 2 (meaning changes with alert type) (optional)
     * @param param3 Parameter 3 (meaning changes with alert type) (optional)
     * @param param4 Parameter 4 (meaning changes with alert type) (optional)
     * @param param5 Parameter 5 (meaning changes with alert type) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call alertsChangeGetAsync(String id, String alertname, Boolean activated, Integer type, Integer channel, String recipient, String param1, String param2, String param3, String param4, String param5, final ApiCallback<List<Domains>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = alertsChangeGetValidateBeforeCall(id, alertname, activated, type, channel, recipient, param1, param2, param3, param4, param5, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for alertsDeleteGet
     * @param id alert id to delete (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call alertsDeleteGetCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/alerts_delete";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call alertsDeleteGetValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling alertsDeleteGet(Async)");
        }
        
        com.squareup.okhttp.Call call = alertsDeleteGetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Permanently delete the alert
     * 
     * @param id alert id to delete (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> alertsDeleteGet(String id) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = alertsDeleteGetWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * Permanently delete the alert
     * 
     * @param id alert id to delete (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> alertsDeleteGetWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = alertsDeleteGetValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Permanently delete the alert (asynchronously)
     * 
     * @param id alert id to delete (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call alertsDeleteGetAsync(String id, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = alertsDeleteGetValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for alertsGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call alertsGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/alerts";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call alertsGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = alertsGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get alerts for user account
     * 
     * @return List&lt;Alerts&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Alerts> alertsGet() throws ApiException {
        ApiResponse<List<Alerts>> resp = alertsGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * Get alerts for user account
     * 
     * @return ApiResponse&lt;List&lt;Alerts&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Alerts>> alertsGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = alertsGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<Alerts>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get alerts for user account (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call alertsGetAsync(final ApiCallback<List<Alerts>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = alertsGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Alerts>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
