/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Favs;
import io.swagger.client.model.TransactionInfo;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class FavsApi {
    private ApiClient apiClient;
    private Map<String, String> headers;

    public FavsApi() {
        this(Configuration.getDefaultApiClient());
    }

    public FavsApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public void setHeadersOverrides(Map<String, String> headers) {
        this.headers = headers;
    }

    /**
     * Build call for favsAddGet
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call favsAddGetCall(String name, String action, String parameters, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/favs_add";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (action != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("action", action));
        if (parameters != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("parameters", parameters));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call favsAddGetValidateBeforeCall(String name, String action, String parameters, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = favsAddGetCall(name, action, parameters, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Create a new fav
     * 
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> favsAddGet(String name, String action, String parameters) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = favsAddGetWithHttpInfo(name, action, parameters);
        return resp.getData();
    }

    /**
     * Create a new fav
     * 
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> favsAddGetWithHttpInfo(String name, String action, String parameters) throws ApiException {
        com.squareup.okhttp.Call call = favsAddGetValidateBeforeCall(name, action, parameters, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Create a new fav (asynchronously)
     * 
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call favsAddGetAsync(String name, String action, String parameters, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = favsAddGetValidateBeforeCall(name, action, parameters, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for favsDeleteGet
     * @param id ID of the fav to delete. (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call favsDeleteGetCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/favs_delete";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call favsDeleteGetValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = favsDeleteGetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Permanently delete the fav
     * 
     * @param id ID of the fav to delete. (optional)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> favsDeleteGet(String id) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = favsDeleteGetWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * Permanently delete the fav
     * 
     * @param id ID of the fav to delete. (optional)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> favsDeleteGetWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = favsDeleteGetValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Permanently delete the fav (asynchronously)
     * 
     * @param id ID of the fav to delete. (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call favsDeleteGetAsync(String id, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = favsDeleteGetValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for favsGet
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call favsGetCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/favs";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call favsGetValidateBeforeCall(String id, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = favsGetCall(id, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get favorites
     * 
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
     * @return List&lt;Favs&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Favs> favsGet(String id) throws ApiException {
        ApiResponse<List<Favs>> resp = favsGetWithHttpInfo(id);
        return resp.getData();
    }

    /**
     * Get favorites
     * 
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
     * @return ApiResponse&lt;List&lt;Favs&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Favs>> favsGetWithHttpInfo(String id) throws ApiException {
        com.squareup.okhttp.Call call = favsGetValidateBeforeCall(id, null, null);
        Type localVarReturnType = new TypeToken<List<Favs>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get favorites (asynchronously)
     * 
     * @param id ID of the requested fav. ignore or set to 0 to get the full favs list (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call favsGetAsync(String id, final ApiCallback<List<Favs>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = favsGetValidateBeforeCall(id, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Favs>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for favsUpdateGet
     * @param id ID of the fav that should be edited (required)
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param scheduled 0 if not scheduled, else x in hours (optional)
     * @param scheduledto email address of the recipient of this report (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call favsUpdateGetCall(String id, String name, String action, String parameters, Integer scheduled, String scheduledto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/favs_update";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));
        if (name != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("name", name));
        if (action != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("action", action));
        if (parameters != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("parameters", parameters));
        if (scheduled != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("scheduled", scheduled));
        if (scheduledto != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("scheduledto", scheduledto));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call favsUpdateGetValidateBeforeCall(String id, String name, String action, String parameters, Integer scheduled, String scheduledto, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling favsUpdateGet(Async)");
        }
        
        com.squareup.okhttp.Call call = favsUpdateGetCall(id, name, action, parameters, scheduled, scheduledto, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Update the fav
     * 
     * @param id ID of the fav that should be edited (required)
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param scheduled 0 if not scheduled, else x in hours (optional)
     * @param scheduledto email address of the recipient of this report (optional)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> favsUpdateGet(String id, String name, String action, String parameters, Integer scheduled, String scheduledto) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = favsUpdateGetWithHttpInfo(id, name, action, parameters, scheduled, scheduledto);
        return resp.getData();
    }

    /**
     * Update the fav
     * 
     * @param id ID of the fav that should be edited (required)
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param scheduled 0 if not scheduled, else x in hours (optional)
     * @param scheduledto email address of the recipient of this report (optional)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> favsUpdateGetWithHttpInfo(String id, String name, String action, String parameters, Integer scheduled, String scheduledto) throws ApiException {
        com.squareup.okhttp.Call call = favsUpdateGetValidateBeforeCall(id, name, action, parameters, scheduled, scheduledto, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Update the fav (asynchronously)
     * 
     * @param id ID of the fav that should be edited (required)
     * @param name Name of the fav. (optional)
     * @param action Action to be opened. (optional)
     * @param parameters Action&#x27;s parameters encoded in JSON. (optional)
     * @param scheduled 0 if not scheduled, else x in hours (optional)
     * @param scheduledto email address of the recipient of this report (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call favsUpdateGetAsync(String id, String name, String action, String parameters, Integer scheduled, String scheduledto, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = favsUpdateGetValidateBeforeCall(id, name, action, parameters, scheduled, scheduledto, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
