/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Categories;
import io.swagger.client.model.Category;
import io.swagger.client.model.Domain;
import io.swagger.client.model.Domains;
import io.swagger.client.model.Page;
import io.swagger.client.model.Pages;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class HistoricalApi {
    private ApiClient apiClient;
    private Map<String, String> headers;

    public HistoricalApi() {
        this(Configuration.getDefaultApiClient());
    }

    public HistoricalApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public void setHeadersOverrides(Map<String, String> headers) {
        this.headers = headers;
    }

    /**
     * Build call for categoriesGet
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call categoriesGetCall(String country, String subcountry, String fromDate, String toDate, String keywordFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/categories";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));
        if (keywordFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyword_filter", keywordFilter));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call categoriesGetValidateBeforeCall(String country, String subcountry, String fromDate, String toDate, String keywordFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling categoriesGet(Async)");
        }
        
        com.squareup.okhttp.Call call = categoriesGetCall(country, subcountry, fromDate, toDate, keywordFilter, lines, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get historical stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Categories&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Categories> categoriesGet(String country, String subcountry, String fromDate, String toDate, String keywordFilter, Integer lines, Integer offset) throws ApiException {
        ApiResponse<List<Categories>> resp = categoriesGetWithHttpInfo(country, subcountry, fromDate, toDate, keywordFilter, lines, offset);
        return resp.getData();
    }

    /**
     * Get historical stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Categories&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Categories>> categoriesGetWithHttpInfo(String country, String subcountry, String fromDate, String toDate, String keywordFilter, Integer lines, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = categoriesGetValidateBeforeCall(country, subcountry, fromDate, toDate, keywordFilter, lines, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Categories>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get historical stats for categories (asynchronously)
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param keywordFilter Filter answers to cateogry names containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call categoriesGetAsync(String country, String subcountry, String fromDate, String toDate, String keywordFilter, Integer lines, Integer offset, final ApiCallback<List<Categories>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = categoriesGetValidateBeforeCall(country, subcountry, fromDate, toDate, keywordFilter, lines, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Categories>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for categoryGet
     * @param id category id (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call categoryGetCall(String id, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/category";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (id != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("id", id));
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call categoryGetValidateBeforeCall(String id, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'id' is set
        if (id == null) {
            throw new ApiException("Missing the required parameter 'id' when calling categoryGet(Async)");
        }
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling categoryGet(Async)");
        }
        
        com.squareup.okhttp.Call call = categoryGetCall(id, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get history for category ID
     * 
     * @param id category id (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return List&lt;Category&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Category> categoryGet(String id, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        ApiResponse<List<Category>> resp = categoryGetWithHttpInfo(id, country, subcountry, fromDate, toDate);
        return resp.getData();
    }

    /**
     * Get history for category ID
     * 
     * @param id category id (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return ApiResponse&lt;List&lt;Category&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Category>> categoryGetWithHttpInfo(String id, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        com.squareup.okhttp.Call call = categoryGetValidateBeforeCall(id, country, subcountry, fromDate, toDate, null, null);
        Type localVarReturnType = new TypeToken<List<Category>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get history for category ID (asynchronously)
     * 
     * @param id category id (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call categoryGetAsync(String id, String country, String subcountry, String fromDate, String toDate, final ApiCallback<List<Category>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = categoryGetValidateBeforeCall(id, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Category>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for domainGet
     * @param domain domain name (no subdomain allowed) (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call domainGetCall(String domain, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/domain";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (domain != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("domain", domain));
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call domainGetValidateBeforeCall(String domain, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'domain' is set
        if (domain == null) {
            throw new ApiException("Missing the required parameter 'domain' when calling domainGet(Async)");
        }
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling domainGet(Async)");
        }
        
        com.squareup.okhttp.Call call = domainGetCall(domain, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get history for domain name
     * 
     * @param domain domain name (no subdomain allowed) (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return List&lt;Domain&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Domain> domainGet(String domain, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        ApiResponse<List<Domain>> resp = domainGetWithHttpInfo(domain, country, subcountry, fromDate, toDate);
        return resp.getData();
    }

    /**
     * Get history for domain name
     * 
     * @param domain domain name (no subdomain allowed) (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return ApiResponse&lt;List&lt;Domain&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Domain>> domainGetWithHttpInfo(String domain, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        com.squareup.okhttp.Call call = domainGetValidateBeforeCall(domain, country, subcountry, fromDate, toDate, null, null);
        Type localVarReturnType = new TypeToken<List<Domain>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get history for domain name (asynchronously)
     * 
     * @param domain domain name (no subdomain allowed) (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call domainGetAsync(String domain, String country, String subcountry, String fromDate, String toDate, final ApiCallback<List<Domain>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = domainGetValidateBeforeCall(domain, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Domain>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for domainsGet
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call domainsGetCall(String country, String subcountry, String fromDate, String toDate, String urlFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/domains";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));
        if (urlFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("url_filter", urlFilter));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call domainsGetValidateBeforeCall(String country, String subcountry, String fromDate, String toDate, String urlFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling domainsGet(Async)");
        }
        
        com.squareup.okhttp.Call call = domainsGetCall(country, subcountry, fromDate, toDate, urlFilter, lines, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get historical stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Domains&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Domains> domainsGet(String country, String subcountry, String fromDate, String toDate, String urlFilter, Integer lines, Integer offset) throws ApiException {
        ApiResponse<List<Domains>> resp = domainsGetWithHttpInfo(country, subcountry, fromDate, toDate, urlFilter, lines, offset);
        return resp.getData();
    }

    /**
     * Get historical stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Domains&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Domains>> domainsGetWithHttpInfo(String country, String subcountry, String fromDate, String toDate, String urlFilter, Integer lines, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = domainsGetValidateBeforeCall(country, subcountry, fromDate, toDate, urlFilter, lines, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get historical stats for domains (asynchronously)
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call domainsGetAsync(String country, String subcountry, String fromDate, String toDate, String urlFilter, Integer lines, Integer offset, final ApiCallback<List<Domains>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = domainsGetValidateBeforeCall(country, subcountry, fromDate, toDate, urlFilter, lines, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for pageGet
     * @param url Fully qualified page url. URL needs to be URL encoded (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call pageGetCall(String url, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/page";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (url != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("url", url));
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call pageGetValidateBeforeCall(String url, String country, String subcountry, String fromDate, String toDate, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'url' is set
        if (url == null) {
            throw new ApiException("Missing the required parameter 'url' when calling pageGet(Async)");
        }
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling pageGet(Async)");
        }
        
        com.squareup.okhttp.Call call = pageGetCall(url, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get page history for URL
     * 
     * @param url Fully qualified page url. URL needs to be URL encoded (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return List&lt;Page&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Page> pageGet(String url, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        ApiResponse<List<Page>> resp = pageGetWithHttpInfo(url, country, subcountry, fromDate, toDate);
        return resp.getData();
    }

    /**
     * Get page history for URL
     * 
     * @param url Fully qualified page url. URL needs to be URL encoded (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @return ApiResponse&lt;List&lt;Page&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Page>> pageGetWithHttpInfo(String url, String country, String subcountry, String fromDate, String toDate) throws ApiException {
        com.squareup.okhttp.Call call = pageGetValidateBeforeCall(url, country, subcountry, fromDate, toDate, null, null);
        Type localVarReturnType = new TypeToken<List<Page>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get page history for URL (asynchronously)
     * 
     * @param url Fully qualified page url. URL needs to be URL encoded (required)
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, datas will adjust to page audience) (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call pageGetAsync(String url, String country, String subcountry, String fromDate, String toDate, final ApiCallback<List<Page>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = pageGetValidateBeforeCall(url, country, subcountry, fromDate, toDate, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Page>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for pagesGet
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param subcountry state code (optional)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to a specific page category (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call pagesGetCall(Integer presetFilter, String fromDate, String toDate, String country, String subcountry, String domainFilter, String urlFilter, Integer categoryFilter, String keywordFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/pages";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (fromDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("from_date", fromDate));
        if (toDate != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("to_date", toDate));
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (domainFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("domain_filter", domainFilter));
        if (urlFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("url_filter", urlFilter));
        if (categoryFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("category_filter", categoryFilter));
        if (keywordFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyword_filter", keywordFilter));
        if (presetFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("preset_filter", presetFilter));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call pagesGetValidateBeforeCall(Integer presetFilter, String fromDate, String toDate, String country, String subcountry, String domainFilter, String urlFilter, Integer categoryFilter, String keywordFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'presetFilter' is set
        if (presetFilter == null) {
            throw new ApiException("Missing the required parameter 'presetFilter' when calling pagesGet(Async)");
        }
        
        com.squareup.okhttp.Call call = pagesGetCall(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get historical stats for pages
     * 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param subcountry state code (optional)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to a specific page category (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Pages&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Pages> pagesGet(Integer presetFilter, String fromDate, String toDate, String country, String subcountry, String domainFilter, String urlFilter, Integer categoryFilter, String keywordFilter, Integer lines, Integer offset) throws ApiException {
        ApiResponse<List<Pages>> resp = pagesGetWithHttpInfo(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset);
        return resp.getData();
    }

    /**
     * Get historical stats for pages
     * 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param subcountry state code (optional)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to a specific page category (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Pages&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Pages>> pagesGetWithHttpInfo(Integer presetFilter, String fromDate, String toDate, String country, String subcountry, String domainFilter, String urlFilter, Integer categoryFilter, String keywordFilter, Integer lines, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = pagesGetValidateBeforeCall(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Pages>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get historical stats for pages (asynchronously)
     * 
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param fromDate Datas from YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param toDate Datas to YYYY-MM-DD (if not provided, last 30 days) (optional)
     * @param country ISO_3166 country code in 2 letters (if not provided  worldwide) (optional)
     * @param subcountry state code (optional)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to a specific page category (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call pagesGetAsync(Integer presetFilter, String fromDate, String toDate, String country, String subcountry, String domainFilter, String urlFilter, Integer categoryFilter, String keywordFilter, Integer lines, Integer offset, final ApiCallback<List<Pages>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = pagesGetValidateBeforeCall(presetFilter, fromDate, toDate, country, subcountry, domainFilter, urlFilter, categoryFilter, keywordFilter, lines, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Pages>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
