/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Categories;
import io.swagger.client.model.Domains;
import io.swagger.client.model.Pages;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class LiveApi {
    private ApiClient apiClient;
    private Map<String, String> headers;

    public LiveApi() {
        this(Configuration.getDefaultApiClient());
    }

    public LiveApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public void setHeadersOverrides(Map<String, String> headers) {
        this.headers = headers;
    }

    /**
     * Build call for livecategoriesGet
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call livecategoriesGetCall(String country, String subcountry, Integer hours, String keywordFilter, String languageFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/livecategories";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (hours != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("hours", hours));
        if (keywordFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyword_filter", keywordFilter));
        if (languageFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("language_filter", languageFilter));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call livecategoriesGetValidateBeforeCall(String country, String subcountry, Integer hours, String keywordFilter, String languageFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling livecategoriesGet(Async)");
        }
        
        com.squareup.okhttp.Call call = livecategoriesGetCall(country, subcountry, hours, keywordFilter, languageFilter, lines, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get livedata stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Categories&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Categories> livecategoriesGet(String country, String subcountry, Integer hours, String keywordFilter, String languageFilter, Integer lines, Integer offset) throws ApiException {
        ApiResponse<List<Categories>> resp = livecategoriesGetWithHttpInfo(country, subcountry, hours, keywordFilter, languageFilter, lines, offset);
        return resp.getData();
    }

    /**
     * Get livedata stats for categories
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Categories&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Categories>> livecategoriesGetWithHttpInfo(String country, String subcountry, Integer hours, String keywordFilter, String languageFilter, Integer lines, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = livecategoriesGetValidateBeforeCall(country, subcountry, hours, keywordFilter, languageFilter, lines, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Categories>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get livedata stats for categories (asynchronously)
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param keywordFilter Filter answers to category names containing a particular keyword (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call livecategoriesGetAsync(String country, String subcountry, Integer hours, String keywordFilter, String languageFilter, Integer lines, Integer offset, final ApiCallback<List<Categories>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = livecategoriesGetValidateBeforeCall(country, subcountry, hours, keywordFilter, languageFilter, lines, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Categories>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for livedomainsGet
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param hours Get results for last x hours (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call livedomainsGetCall(String country, String subcountry, String urlFilter, Integer hours, Integer lines, String languageFilter, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/livedomains";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (urlFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("url_filter", urlFilter));
        if (hours != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("hours", hours));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (languageFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("language_filter", languageFilter));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call livedomainsGetValidateBeforeCall(String country, String subcountry, String urlFilter, Integer hours, Integer lines, String languageFilter, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling livedomainsGet(Async)");
        }
        
        com.squareup.okhttp.Call call = livedomainsGetCall(country, subcountry, urlFilter, hours, lines, languageFilter, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get livedata stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param hours Get results for last x hours (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Domains&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Domains> livedomainsGet(String country, String subcountry, String urlFilter, Integer hours, Integer lines, String languageFilter, Integer offset) throws ApiException {
        ApiResponse<List<Domains>> resp = livedomainsGetWithHttpInfo(country, subcountry, urlFilter, hours, lines, languageFilter, offset);
        return resp.getData();
    }

    /**
     * Get livedata stats for domains
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param hours Get results for last x hours (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Domains&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Domains>> livedomainsGetWithHttpInfo(String country, String subcountry, String urlFilter, Integer hours, Integer lines, String languageFilter, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = livedomainsGetValidateBeforeCall(country, subcountry, urlFilter, hours, lines, languageFilter, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get livedata stats for domains (asynchronously)
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param subcountry state code (optional)
     * @param urlFilter Filter answers to domains including a specified string (optional)
     * @param hours Get results for last x hours (optional)
     * @param lines Get X results (max in one request is 10K please use offset paginated results if you need more) (optional, default to 50)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call livedomainsGetAsync(String country, String subcountry, String urlFilter, Integer hours, Integer lines, String languageFilter, Integer offset, final ApiCallback<List<Domains>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = livedomainsGetValidateBeforeCall(country, subcountry, urlFilter, hours, lines, languageFilter, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Domains>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for livepagesGet
     * @param country ISO_3166 country code in 2 letters (required)
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to pages of a designated category id (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call livepagesGetCall(String country, Integer presetFilter, String subcountry, Integer hours, Integer onlyNew, String domainFilter, String keywordFilter, String urlFilter, Integer categoryFilter, String languageFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/livepages";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (country != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("country", country));
        if (subcountry != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("subcountry", subcountry));
        if (hours != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("hours", hours));
        if (presetFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("preset_filter", presetFilter));
        if (onlyNew != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("only_new", onlyNew));
        if (domainFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("domain_filter", domainFilter));
        if (keywordFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("keyword_filter", keywordFilter));
        if (urlFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("url_filter", urlFilter));
        if (categoryFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("category_filter", categoryFilter));
        if (languageFilter != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("language_filter", languageFilter));
        if (lines != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lines", lines));
        if (offset != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("offset", offset));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call livepagesGetValidateBeforeCall(String country, Integer presetFilter, String subcountry, Integer hours, Integer onlyNew, String domainFilter, String keywordFilter, String urlFilter, Integer categoryFilter, String languageFilter, Integer lines, Integer offset, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'country' is set
        if (country == null) {
            throw new ApiException("Missing the required parameter 'country' when calling livepagesGet(Async)");
        }
        // verify the required parameter 'presetFilter' is set
        if (presetFilter == null) {
            throw new ApiException("Missing the required parameter 'presetFilter' when calling livepagesGet(Async)");
        }
        
        com.squareup.okhttp.Call call = livepagesGetCall(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get livedata stats for pages
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to pages of a designated category id (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return List&lt;Pages&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Pages> livepagesGet(String country, Integer presetFilter, String subcountry, Integer hours, Integer onlyNew, String domainFilter, String keywordFilter, String urlFilter, Integer categoryFilter, String languageFilter, Integer lines, Integer offset) throws ApiException {
        ApiResponse<List<Pages>> resp = livepagesGetWithHttpInfo(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset);
        return resp.getData();
    }

    /**
     * Get livedata stats for pages
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to pages of a designated category id (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @return ApiResponse&lt;List&lt;Pages&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Pages>> livepagesGetWithHttpInfo(String country, Integer presetFilter, String subcountry, Integer hours, Integer onlyNew, String domainFilter, String keywordFilter, String urlFilter, Integer categoryFilter, String languageFilter, Integer lines, Integer offset) throws ApiException {
        com.squareup.okhttp.Call call = livepagesGetValidateBeforeCall(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset, null, null);
        Type localVarReturnType = new TypeToken<List<Pages>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get livedata stats for pages (asynchronously)
     * 
     * @param country ISO_3166 country code in 2 letters (required)
     * @param presetFilter Apply preset filters &#x3D;&gt; 0 no filter 1 no newsstories 2 only newsstories 3 only sapphire 4 only moonstone 5 sapphire and moonstone combined 6 sapphire or moonstone (required)
     * @param subcountry state code (optional)
     * @param hours Get results for last x hours (optional)
     * @param onlyNew Get only pages first seen in the reporting period if set on 1 (optional, default to 0)
     * @param domainFilter Filter answers to pages of a designated domain name (optional)
     * @param keywordFilter Filter answers to pages titles containing a particular keyword (optional)
     * @param urlFilter Filter answers to pages URL including a specified string (optional)
     * @param categoryFilter Filter answers to pages of a designated category id (optional)
     * @param languageFilter Filter answers to pages in specific user language (optional)
     * @param lines Get X results (max in one request is 50 please use offset paginated results if you need more) (optional, default to 50)
     * @param offset Get paginated results from X offset (optional, default to 0)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call livepagesGetAsync(String country, Integer presetFilter, String subcountry, Integer hours, Integer onlyNew, String domainFilter, String keywordFilter, String urlFilter, Integer categoryFilter, String languageFilter, Integer lines, Integer offset, final ApiCallback<List<Pages>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = livepagesGetValidateBeforeCall(country, presetFilter, subcountry, hours, onlyNew, domainFilter, keywordFilter, urlFilter, categoryFilter, languageFilter, lines, offset, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Pages>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
