/*
 * DiscoverSnoop
 * API for DiscoverSnoop Service
 *
 * OpenAPI spec version: 0.9.240913
 * 
 *
 * NOTE: This class is auto generated by the swagger code generator program.
 * https://github.com/swagger-api/swagger-codegen.git
 * Do not edit the class manually.
 */

package io.swagger.client.api;

import io.swagger.client.ApiCallback;
import io.swagger.client.ApiClient;
import io.swagger.client.ApiException;
import io.swagger.client.ApiResponse;
import io.swagger.client.Configuration;
import io.swagger.client.Pair;
import io.swagger.client.ProgressRequestBody;
import io.swagger.client.ProgressResponseBody;

import com.google.gson.reflect.TypeToken;

import java.io.IOException;


import io.swagger.client.model.Message;
import io.swagger.client.model.TransactionInfo;
import io.swagger.client.model.UserInfo;

import java.lang.reflect.Type;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

public class UserApi {
    private ApiClient apiClient;
    private Map<String, String> headers;

    public UserApi() {
        this(Configuration.getDefaultApiClient());
    }

    public UserApi(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public ApiClient getApiClient() {
        return apiClient;
    }

    public void setApiClient(ApiClient apiClient) {
        this.apiClient = apiClient;
    }

    public void setHeadersOverrides(Map<String, String> headers) {
        this.headers = headers;
    }

    /**
     * Build call for userCountriesChangeGet
     * @param countries json encoded string representing countries to activate (required)
     * @param categories json encoded string representing categories ID to activate (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCountriesChangeGetCall(String countries, String categories, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_countries_change";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (countries != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("countries", countries));
        if (categories != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("categories", categories));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCountriesChangeGetValidateBeforeCall(String countries, String categories, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'countries' is set
        if (countries == null) {
            throw new ApiException("Missing the required parameter 'countries' when calling userCountriesChangeGet(Async)");
        }
        // verify the required parameter 'categories' is set
        if (categories == null) {
            throw new ApiException("Missing the required parameter 'categories' when calling userCountriesChangeGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userCountriesChangeGetCall(countries, categories, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Change user&#x27;s activated countries
     * 
     * @param countries json encoded string representing countries to activate (required)
     * @param categories json encoded string representing categories ID to activate (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userCountriesChangeGet(String countries, String categories) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userCountriesChangeGetWithHttpInfo(countries, categories);
        return resp.getData();
    }

    /**
     * Change user&#x27;s activated countries
     * 
     * @param countries json encoded string representing countries to activate (required)
     * @param categories json encoded string representing categories ID to activate (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userCountriesChangeGetWithHttpInfo(String countries, String categories) throws ApiException {
        com.squareup.okhttp.Call call = userCountriesChangeGetValidateBeforeCall(countries, categories, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Change user&#x27;s activated countries (asynchronously)
     * 
     * @param countries json encoded string representing countries to activate (required)
     * @param categories json encoded string representing categories ID to activate (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCountriesChangeGetAsync(String countries, String categories, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCountriesChangeGetValidateBeforeCall(countries, categories, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userCustidChangeGet
     * @param custid new customer id for user (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userCustidChangeGetCall(String custid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_custid_change";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (custid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("custid", custid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userCustidChangeGetValidateBeforeCall(String custid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'custid' is set
        if (custid == null) {
            throw new ApiException("Missing the required parameter 'custid' when calling userCustidChangeGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userCustidChangeGetCall(custid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Change user customer id. This function is system reserved
     * 
     * @param custid new customer id for user (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userCustidChangeGet(String custid) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userCustidChangeGetWithHttpInfo(custid);
        return resp.getData();
    }

    /**
     * Change user customer id. This function is system reserved
     * 
     * @param custid new customer id for user (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userCustidChangeGetWithHttpInfo(String custid) throws ApiException {
        com.squareup.okhttp.Call call = userCustidChangeGetValidateBeforeCall(custid, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Change user customer id. This function is system reserved (asynchronously)
     * 
     * @param custid new customer id for user (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userCustidChangeGetAsync(String custid, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userCustidChangeGetValidateBeforeCall(custid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userDeleteGet
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userDeleteGetCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_delete";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userDeleteGetValidateBeforeCall(final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = userDeleteGetCall(progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Permanently delete the user
     * 
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userDeleteGet() throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userDeleteGetWithHttpInfo();
        return resp.getData();
    }

    /**
     * Permanently delete the user
     * 
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userDeleteGetWithHttpInfo() throws ApiException {
        com.squareup.okhttp.Call call = userDeleteGetValidateBeforeCall(null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Permanently delete the user (asynchronously)
     * 
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userDeleteGetAsync(final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userDeleteGetValidateBeforeCall(progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userDetailsChangeGet
     * @param email new email address for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userDetailsChangeGetCall(String email, String fname, String lname, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_details_change";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (email != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("email", email));
        if (fname != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fname", fname));
        if (lname != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lname", lname));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userDetailsChangeGetValidateBeforeCall(String email, String fname, String lname, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling userDetailsChangeGet(Async)");
        }
        // verify the required parameter 'fname' is set
        if (fname == null) {
            throw new ApiException("Missing the required parameter 'fname' when calling userDetailsChangeGet(Async)");
        }
        // verify the required parameter 'lname' is set
        if (lname == null) {
            throw new ApiException("Missing the required parameter 'lname' when calling userDetailsChangeGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userDetailsChangeGetCall(email, fname, lname, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Change user details
     * 
     * @param email new email address for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userDetailsChangeGet(String email, String fname, String lname) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userDetailsChangeGetWithHttpInfo(email, fname, lname);
        return resp.getData();
    }

    /**
     * Change user details
     * 
     * @param email new email address for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userDetailsChangeGetWithHttpInfo(String email, String fname, String lname) throws ApiException {
        com.squareup.okhttp.Call call = userDetailsChangeGetValidateBeforeCall(email, fname, lname, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Change user details (asynchronously)
     * 
     * @param email new email address for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userDetailsChangeGetAsync(String email, String fname, String lname, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userDetailsChangeGetValidateBeforeCall(email, fname, lname, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userLoginGet
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userLoginGetCall(String email, String password, Integer pin, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_login";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (email != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("email", email));
        if (password != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("password", password));
        if (pin != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("pin", pin));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userLoginGetValidateBeforeCall(String email, String password, Integer pin, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling userLoginGet(Async)");
        }
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling userLoginGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userLoginGetCall(email, password, pin, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
     * @return List&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserInfo> userLoginGet(String email, String password, Integer pin) throws ApiException {
        ApiResponse<List<UserInfo>> resp = userLoginGetWithHttpInfo(email, password, pin);
        return resp.getData();
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
     * @return ApiResponse&lt;List&lt;UserInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserInfo>> userLoginGetWithHttpInfo(String email, String password, Integer pin) throws ApiException {
        com.squareup.okhttp.Call call = userLoginGetValidateBeforeCall(email, password, pin, null, null);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Login user with his credentials (asynchronously)
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param pin pin code to validate account creation ; when using pin code, password must be set to \&quot;loginwithpin\&quot; (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userLoginGetAsync(String email, String password, Integer pin, final ApiCallback<List<UserInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userLoginGetValidateBeforeCall(email, password, pin, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userMessagesGet
     * @param message ID of the requested message. 0 to get the full message list (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userMessagesGetCall(Integer message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_messages";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (message != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("message", message));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userMessagesGetValidateBeforeCall(Integer message, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        
        com.squareup.okhttp.Call call = userMessagesGetCall(message, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Get messages for user
     * 
     * @param message ID of the requested message. 0 to get the full message list (optional)
     * @return List&lt;Message&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<Message> userMessagesGet(Integer message) throws ApiException {
        ApiResponse<List<Message>> resp = userMessagesGetWithHttpInfo(message);
        return resp.getData();
    }

    /**
     * Get messages for user
     * 
     * @param message ID of the requested message. 0 to get the full message list (optional)
     * @return ApiResponse&lt;List&lt;Message&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<Message>> userMessagesGetWithHttpInfo(Integer message) throws ApiException {
        com.squareup.okhttp.Call call = userMessagesGetValidateBeforeCall(message, null, null);
        Type localVarReturnType = new TypeToken<List<Message>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Get messages for user (asynchronously)
     * 
     * @param message ID of the requested message. 0 to get the full message list (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userMessagesGetAsync(Integer message, final ApiCallback<List<Message>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userMessagesGetValidateBeforeCall(message, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<Message>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userPasswordChangeGet
     * @param email email address for user (required)
     * @param password current password for user (required)
     * @param newpassword new password to set up for user (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userPasswordChangeGetCall(String email, String password, String newpassword, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_password_change";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (email != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("email", email));
        if (password != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("password", password));
        if (newpassword != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("newpassword", newpassword));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userPasswordChangeGetValidateBeforeCall(String email, String password, String newpassword, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling userPasswordChangeGet(Async)");
        }
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling userPasswordChangeGet(Async)");
        }
        // verify the required parameter 'newpassword' is set
        if (newpassword == null) {
            throw new ApiException("Missing the required parameter 'newpassword' when calling userPasswordChangeGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userPasswordChangeGetCall(email, password, newpassword, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Change user password
     * 
     * @param email email address for user (required)
     * @param password current password for user (required)
     * @param newpassword new password to set up for user (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userPasswordChangeGet(String email, String password, String newpassword) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userPasswordChangeGetWithHttpInfo(email, password, newpassword);
        return resp.getData();
    }

    /**
     * Change user password
     * 
     * @param email email address for user (required)
     * @param password current password for user (required)
     * @param newpassword new password to set up for user (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userPasswordChangeGetWithHttpInfo(String email, String password, String newpassword) throws ApiException {
        com.squareup.okhttp.Call call = userPasswordChangeGetValidateBeforeCall(email, password, newpassword, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Change user password (asynchronously)
     * 
     * @param email email address for user (required)
     * @param password current password for user (required)
     * @param newpassword new password to set up for user (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userPasswordChangeGetAsync(String email, String password, String newpassword, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userPasswordChangeGetValidateBeforeCall(email, password, newpassword, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userPasswordResetGet
     * @param email email address for user (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userPasswordResetGetCall(String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_password_reset";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (email != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("email", email));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userPasswordResetGetValidateBeforeCall(String email, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling userPasswordResetGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userPasswordResetGetCall(email, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Reset user password
     * 
     * @param email email address for user (required)
     * @return List&lt;TransactionInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<TransactionInfo> userPasswordResetGet(String email) throws ApiException {
        ApiResponse<List<TransactionInfo>> resp = userPasswordResetGetWithHttpInfo(email);
        return resp.getData();
    }

    /**
     * Reset user password
     * 
     * @param email email address for user (required)
     * @return ApiResponse&lt;List&lt;TransactionInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<TransactionInfo>> userPasswordResetGetWithHttpInfo(String email) throws ApiException {
        com.squareup.okhttp.Call call = userPasswordResetGetValidateBeforeCall(email, null, null);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Reset user password (asynchronously)
     * 
     * @param email email address for user (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userPasswordResetGetAsync(String email, final ApiCallback<List<TransactionInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userPasswordResetGetValidateBeforeCall(email, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<TransactionInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userRefreshSubscriptionGet
     * @param custid Customer ID for the user (required)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userRefreshSubscriptionGetCall(String custid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_refresh_subscription";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (custid != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("custid", custid));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userRefreshSubscriptionGetValidateBeforeCall(String custid, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'custid' is set
        if (custid == null) {
            throw new ApiException("Missing the required parameter 'custid' when calling userRefreshSubscriptionGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userRefreshSubscriptionGetCall(custid, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Refresh user rights with his Customer ID. This function is system reserved
     * 
     * @param custid Customer ID for the user (required)
     * @return List&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserInfo> userRefreshSubscriptionGet(String custid) throws ApiException {
        ApiResponse<List<UserInfo>> resp = userRefreshSubscriptionGetWithHttpInfo(custid);
        return resp.getData();
    }

    /**
     * Refresh user rights with his Customer ID. This function is system reserved
     * 
     * @param custid Customer ID for the user (required)
     * @return ApiResponse&lt;List&lt;UserInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserInfo>> userRefreshSubscriptionGetWithHttpInfo(String custid) throws ApiException {
        com.squareup.okhttp.Call call = userRefreshSubscriptionGetValidateBeforeCall(custid, null, null);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Refresh user rights with his Customer ID. This function is system reserved (asynchronously)
     * 
     * @param custid Customer ID for the user (required)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userRefreshSubscriptionGetAsync(String custid, final ApiCallback<List<UserInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userRefreshSubscriptionGetValidateBeforeCall(custid, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
    /**
     * Build call for userRegisterGet
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param referrer referrer for this user. should be urlencoded (optional)
     * @param progressListener Progress listener
     * @param progressRequestListener Progress request listener
     * @return Call to execute
     * @throws ApiException If fail to serialize the request body object
     */
    public com.squareup.okhttp.Call userRegisterGetCall(String email, String password, String fname, String lname, String referrer, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        Object localVarPostBody = null;
        
        // create path and map variables
        String localVarPath = "/user_register";

        List<Pair> localVarQueryParams = new ArrayList<Pair>();
        List<Pair> localVarCollectionQueryParams = new ArrayList<Pair>();
        if (email != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("email", email));
        if (password != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("password", password));
        if (fname != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("fname", fname));
        if (lname != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("lname", lname));
        if (referrer != null)
        localVarQueryParams.addAll(apiClient.parameterToPair("referrer", referrer));

        Map<String, String> localVarHeaderParams = new HashMap<String, String>();

        Map<String, Object> localVarFormParams = new HashMap<String, Object>();

        final String[] localVarAccepts = {
            "application/json"
        };
        final String localVarAccept = apiClient.selectHeaderAccept(localVarAccepts);
        if (localVarAccept != null) localVarHeaderParams.put("Accept", localVarAccept);

        final String[] localVarContentTypes = {
            
        };
        final String localVarContentType = apiClient.selectHeaderContentType(localVarContentTypes);
        localVarHeaderParams.put("Content-Type", localVarContentType);

        if(progressListener != null) {
            apiClient.getHttpClient().networkInterceptors().add(new com.squareup.okhttp.Interceptor() {
                @Override
                public com.squareup.okhttp.Response intercept(com.squareup.okhttp.Interceptor.Chain chain) throws IOException {
                    com.squareup.okhttp.Response originalResponse = chain.proceed(chain.request());
                    return originalResponse.newBuilder()
                    .body(new ProgressResponseBody(originalResponse.body(), progressListener))
                    .build();
                }
            });
        }

        String[] localVarAuthNames = new String[] { "bearerAuth" };
        if (headers != null) {
            localVarHeaderParams.putAll(headers);
        }
        return apiClient.buildCall(localVarPath, "GET", localVarQueryParams, localVarCollectionQueryParams, localVarPostBody, localVarHeaderParams, localVarFormParams, localVarAuthNames, progressRequestListener);
    }
    
    @SuppressWarnings("rawtypes")
    private com.squareup.okhttp.Call userRegisterGetValidateBeforeCall(String email, String password, String fname, String lname, String referrer, final ProgressResponseBody.ProgressListener progressListener, final ProgressRequestBody.ProgressRequestListener progressRequestListener) throws ApiException {
        // verify the required parameter 'email' is set
        if (email == null) {
            throw new ApiException("Missing the required parameter 'email' when calling userRegisterGet(Async)");
        }
        // verify the required parameter 'password' is set
        if (password == null) {
            throw new ApiException("Missing the required parameter 'password' when calling userRegisterGet(Async)");
        }
        // verify the required parameter 'fname' is set
        if (fname == null) {
            throw new ApiException("Missing the required parameter 'fname' when calling userRegisterGet(Async)");
        }
        // verify the required parameter 'lname' is set
        if (lname == null) {
            throw new ApiException("Missing the required parameter 'lname' when calling userRegisterGet(Async)");
        }
        
        com.squareup.okhttp.Call call = userRegisterGetCall(email, password, fname, lname, referrer, progressListener, progressRequestListener);
        return call;

        
        
        
        
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param referrer referrer for this user. should be urlencoded (optional)
     * @return List&lt;UserInfo&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public List<UserInfo> userRegisterGet(String email, String password, String fname, String lname, String referrer) throws ApiException {
        ApiResponse<List<UserInfo>> resp = userRegisterGetWithHttpInfo(email, password, fname, lname, referrer);
        return resp.getData();
    }

    /**
     * Login user with his credentials
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param referrer referrer for this user. should be urlencoded (optional)
     * @return ApiResponse&lt;List&lt;UserInfo&gt;&gt;
     * @throws ApiException If fail to call the API, e.g. server error or cannot deserialize the response body
     */
    public ApiResponse<List<UserInfo>> userRegisterGetWithHttpInfo(String email, String password, String fname, String lname, String referrer) throws ApiException {
        com.squareup.okhttp.Call call = userRegisterGetValidateBeforeCall(email, password, fname, lname, referrer, null, null);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        return apiClient.execute(call, localVarReturnType);
    }

    /**
     * Login user with his credentials (asynchronously)
     * 
     * @param email email address for user (required)
     * @param password password for user (required)
     * @param fname new firstname for user (required)
     * @param lname new lastname for user (required)
     * @param referrer referrer for this user. should be urlencoded (optional)
     * @param callback The callback to be executed when the API call finishes
     * @return The request call
     * @throws ApiException If fail to process the API call, e.g. serializing the request body object
     */
    public com.squareup.okhttp.Call userRegisterGetAsync(String email, String password, String fname, String lname, String referrer, final ApiCallback<List<UserInfo>> callback) throws ApiException {

        ProgressResponseBody.ProgressListener progressListener = null;
        ProgressRequestBody.ProgressRequestListener progressRequestListener = null;

        if (callback != null) {
            progressListener = new ProgressResponseBody.ProgressListener() {
                @Override
                public void update(long bytesRead, long contentLength, boolean done) {
                    callback.onDownloadProgress(bytesRead, contentLength, done);
                }
            };

            progressRequestListener = new ProgressRequestBody.ProgressRequestListener() {
                @Override
                public void onRequestProgress(long bytesWritten, long contentLength, boolean done) {
                    callback.onUploadProgress(bytesWritten, contentLength, done);
                }
            };
        }

        com.squareup.okhttp.Call call = userRegisterGetValidateBeforeCall(email, password, fname, lname, referrer, progressListener, progressRequestListener);
        Type localVarReturnType = new TypeToken<List<UserInfo>>(){}.getType();
        apiClient.executeAsync(call, localVarReturnType, callback);
        return call;
    }
}
